<?php
/*
Plugin Name: FLV Embed
Plugin URI: http://www.channel-ai.com/blog/plugins/flv-embed/
Description: Standards compliant FLV embedding in your blog posts using SWFObject by Geoff and FLV Player by Jeroen
Version: 0.3.2
Author: Yaosan Yeo
Author URI: http://www.channel-ai.com/blog/
*/

/*  Copyright 2007  Yaosan Yeo  (email : eyn@channel-ai.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// configurable variables (global variables)

	$flv_useposter = 0;				// Set this to 1 if you want to display poster frame i.e. preview image
	$flv_posterinfeed = 0;			// Set this to 1 to allow RSS reader to see the poster image with a link to the flash player
	$flv_imagetype = "jpg";			// Preview image extension, can be "jpg", "png" or "gif" (this applies to autolocate poster feature i.e. the player will look for image with the same filename as the FLV file within same directory)

	$flv_posterpath = "";			// Path to directory of poster images (trailing slash required). If only filename is given (i.e. not absolute or site relative path) when using embed tags, the filename will be appended to this path. Leave blank if not required. (this property has no effect if $flv_useposter = 0)

	$flv_flvpath = "";				// Path to directory of flv files (trailing slash required). If only filename is given (i.e. not absolute or site relative path) when using embed tags, the filename will be appended to this path. leave blank if not required.

	$flv_backcolor = "FFFFFF";		// Background color of the flvplayer
	$flv_frontcolor = "000000";		// Texts / buttons color of the flvplayer
	$flv_lightcolor = "000000";		// Rollover/ active color of the flvplayer

	$flv_logo = "";					// Set the URL to an image to be used as a watermark logo in the bottom right corner of the display, transparent PNG works the best
	$flv_link = "";					// Set the URL you want the logo to link to

	$flv_overstretch = "fit";		// Defines how to stretch images/movies to make them fit the display. "true" will stretch them proportionally to fill the display, "false" will stretch them to fit. "fit" will stretch them disproportionally to fit both height and width. "none" will show all items in their original dimensions. Defaults to "fit".

	$flv_showdigits = 1;			// Set this to 1 to show the digits for % loaded, elapsed and remaining time in the flvplayer
	$flv_showicons = 1;				// Set this to 1 to show the play and activitiy icons in the middle of the display
	$flv_showfsbutton = 1;			// Set this to 1 to show the fullscreen button
	$flv_showcontrolbar = 1;		// Set this to 1 to show the control bar

	$flv_autostart = 0;				// Set this to 1 if you want the flv player to automatically start playing (not recommended)
	$flv_bufferlength = 5;			// This sets the number of seconds an FLV should be buffered ahead before the player starts it. Set this smaller for fast connections or short videos. Set this bigger for slow connections. The default is 5 seconds.
	$flv_volume = 80;				// The default volume for playback of sounds/movies is 80 (%), but you can set another startup value

// end of configurable variables

	$flv_counter = 0;					// Count how many players are inserted

function flv_parse($content)
{
	$content = preg_replace_callback( "/\[flv:(([^]]+))]/i", "flv_embed", $content );
	return $content;
}

function flv_addVariable($var, $value) {
	global $flv_counter;
	
	$output = "\n\t" . 's' . $flv_counter . '.addVariable("' . $var . '","' . $value . '");';
	return $output;
}

function flv_embed($matches)
{
	global $post, $flv_autostart, $flv_showdigits, $flv_showicons, $flv_showfsbutton, $flv_showcontrolbar, $flv_bufferlength, $flv_overstretch, $flv_logo, $flv_link, $flv_useposter, $flv_posterinfeed, $flv_imagetype, $flv_posterpath, $flv_flvpath, $flv_volume, $flv_backcolor, $flv_frontcolor, $flv_lightcolor, $flv_counter;

	$fs = get_settings('siteurl') . '/wp-content/plugins/flv-embed/fullscreen.php';
	$player = get_settings('siteurl') . '/wp-content/plugins/flv-embed/flvplayer.swf';
	$return = get_permalink($post->ID);

	$input = explode(" ", $matches[2]);
	$arg = count($input);
	
	// gets number of arguments to see if poster path is provided
	if ($arg == 4) {
		list($movie, $poster, $width, $height) = $input;
	} else {
		list($movie, $width, $height) = $input;
	}
	
	$flv_counter++;
	
	// flv file location
	$usepath = 1;
	
	if ( (substr($movie,0,1) == '/') || (stristr($movie, "://")) )	// test site relative and absolute path
		$usepath = 0;
		
	if ($usepath)
		$movie = $flv_flvpath . $movie;

	$file = flv_addVariable("file", $movie);
	
	// controller show/hide
	if ($flv_showcontrolbar) {
		$height += 20;		// Extra 20px for controller bar
		$displayheight = "";
	} else {
		$displayheight = flv_addVariable("displayheight", $height);
	}
	
	// poster
	if ($flv_useposter) {
		if (empty($poster)) {
			
			// assume poster is in the same directory as flv file
			if (empty($flv_posterpath)) {
				$image = str_replace(".flv", ".", $movie);
				$posterpath = $image . $flv_imagetype;
			}
			
			// use poster path configured in global variables
			else {
				$image = basename($movie, ".flv");
				$posterpath = $flv_posterpath . $image . "." . $flv_imagetype;
			}
		
		} else {
			$usepath = 1;
			
			// test site relative and absolute path
			if ( (substr($poster,0,1) == '/') || (stristr($poster, "://")) )
				$usepath = 0;
			
			// if not relative or absolute path, add poster path configured in global variables
			if ($usepath) {
				$posterpath = $flv_posterpath . $poster;
			} else {
				$posterpath = $poster;
			}
		}
		
		$image = flv_addVariable("image", $posterpath);
	}
	
	// return custom message for RSS feeds
	if (is_feed()) {
		if ( ($flv_posterinfeed) && (!empty($posterpath)) ) {
			// get full url of poster (which requires changing site relative path to absolute) to be used as optional preview image in RSS feeds
			
			// if NOT absolute path i.e. we need to add host name to path
			if (!stristr($poster, "://")) {
				$purl = parse_url(get_settings('siteurl'));
				$posterpath = "http://" . $purl["host"] . $posterpath;
			}
			
			return "<a href=\"$return\" title=\"Watch Flash video!\"><img src=\"$posterpath\" alt=\"preview image\"/></a>";
		} else {
			return "[See post to watch Flash video]";
		}
	}
	
	// colours
	$backcolor = ($flv_backcolor == "FFFFFF") ? "" : flv_addVariable("backcolor", "0x" . $flv_backcolor);
	$frontcolor = ($flv_frontcolor == "000000") ? "" : flv_addVariable("frontcolor", "0x" . $flv_frontcolor);
	$lightcolor = ($flv_lightcolor == "000000") ? "" : flv_addVariable("lightcolor", "0x" . $flv_lightcolor); 
	
	// logo
	$logo = (empty($flv_logo)) ? "" : flv_addVariable("logo", $flv_logo);
	
	// link
	$link = (empty($flv_link)) ? "" : flv_addVariable("link", $flv_link);
	
	// overstretch
	$overstretch = ($flv_overstretch == "fit") ? "" : flv_addVariable("overstretch", $flv_overstretch);

	// showdigit
	$showdigits = ($flv_showdigits) ? "" : flv_addVariable("showdigits", "false");
	
	// showicons
	$showicons = ($flv_showicons) ? "" : flv_addVariable("showicons", "false");
	
	// autostart
	$autostart = ($flv_autostart) ? flv_addVariable("autostart", "true") : "";
	
	// bufferlength
	$bufferlength = ($flv_bufferlength == 5) ? "" : flv_addVariable("bufferlength", $flv_bufferlength);
	
	// volume
	$volume = ($flv_volume == 80) ? "" : flv_addVariable("volume", $flv_volume);
	
	// fullscreen
	if ($flv_showfsbutton) {
		$fsbuttonlink = flv_addVariable("fsbuttonlink", "$fs?f=$movie%26r=$return");
	} else {
		$usefullscreen = flv_addVariable("usefullscreen", "false");
	}
	
	// start outputting javascript
	ob_start();
	print <<< SWF
</p><p id="player{$flv_counter}" style="display:none"><a href="http://www.macromedia.com/go/getflashplayer">Get the latest Flash Player</a> to see this player.</p>
<noscript><p>[Javascript required to view Flash movie, please turn it on and refresh this page]</p></noscript>

<script type="text/javascript">
	document.getElementById("player{$flv_counter}").style.display = "";
	
	var s{$flv_counter} = new SWFObject("{$player}","player{$flv_counter}","{$width}","{$height}","7");
	s{$flv_counter}.addParam("allowfullscreen","true");
	s{$flv_counter}.addVariable("height","{$height}");
	s{$flv_counter}.addVariable("width","{$width}"); {$displayheight}{$file}{$image}{$backcolor}{$frontcolor}{$lightcolor}{$logo}{$link}{$overstretch}{$showdigits}{$showicons}{$autostart}{$bufferlength}{$volume}{$fsbuttonlink}{$usefullscreen}
	s{$flv_counter}.write("player{$flv_counter}");
</script><p>
SWF;
	$output = ob_get_contents();
	ob_end_clean();

	return $output;
}

add_filter('the_content', 'flv_parse');
//add_filter('the_excerpt', 'flv_parse');

// Import external javascript in Wordpress header
function flv_head() {
	$path = get_settings('siteurl') . '/wp-content/plugins/flv-embed/swfobject.js';
	echo '<script type="text/javascript" src="' . $path . '"></script>';
	echo "\n";
}

add_action('wp_head', 'flv_head');
?>
